PrimeUIHandler = class(Turbine.UI.Control)
function PrimeUIHandler:Constructor()
    Turbine.UI.Control.Constructor(self)

    self.tools = {}

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self.UIData = {
        [1] = {
            ["InstanceLoad"] = nil,
            ["RoleLoad"] = nil,
            ["ClassLoad"] = nil,
            ["CharLoad"] = nil,
            ["Name"] = "Big test UI",
            ["PrimeUI"] = {
                [1] = {
                    ["Order"] = 2,
                    ["Type"] = "Skills",
                    ["OffsetAbove"] = 0,
                    ["OffsetBelow"] = 0,
                    ["Scale"] = 1,
                    ["Skills"] = {
                        [1] = {
                            ["ID"] = "0x70058AC1",
                            ["Name"] = "Low Strike",
                            ["XPrio"] = 1,
                            ["YPrio"] = 1,
                        },
                        [2] = {
                            ["ID"] = "0x70058AC0",
                            ["Name"] = "Dextrous Hook",
                            ["XPrio"] = 2,
                            ["YPrio"] = 1,
                        },
                        [3] = {
                            ["ID"] = "0x70058AC8",
                            ["Name"] = "Sinister Cross",
                            ["XPrio"] = 1,
                            ["YPrio"] = 2,
                        },
                        [4] = {
                            ["ID"] = "0x70003F3D",
                            ["Name"] = "Find the Path",
                            ["XPrio"] = 1,
                            ["YPrio"] = 2,
                        },
                    }
                },
                [2] = {
                    ["Order"] = 3,
                    ["Type"] = "Skills",
                    ["OffsetAbove"] = 0,
                    ["OffsetBelow"] = 0,
                    ["Scale"] = 2,
                    ["Skills"] = {
                        [1] = {
                            ["ID"] = "0x70058AC1",
                            ["Name"] = "Low Strike",
                            ["XPrio"] = 1,
                            ["YPrio"] = 1,
                        },
                        [2] = {
                            ["ID"] = "0x70058AC0",
                            ["Name"] = "Dextrous Hook",
                            ["XPrio"] = 2,
                            ["YPrio"] = 1,
                        },
                        [3] = {
                            ["ID"] = "0x70058AC8",
                            ["Name"] = "Sinister Cross",
                            ["XPrio"] = 1,
                            ["YPrio"] = 2,
                        },
                        [4] = {
                            ["ID"] = "0x70003F3D",
                            ["Name"] = "Find the Path",
                            ["XPrio"] = 1,
                            ["YPrio"] = 2,
                        },
                    },
                },
                [3] = {
                    ["Order"] = 1,
                    ["Type"] = "MoraleBar",
                    ["OffsetAbove"] = 0,
                    ["OffsetBelow"] = 0,
                    ["Height"] = 20,
                    ["Text"] = "<current>/<total> (<percentage>%)",
                    ["Smooth"] = true,
                    ["Colours"] = {[1] = {[1] = 0.6, [2] = 0, [3] = 0.5, [4] = 0}, [2] = {[1] = 0.6, [2] = 0, [3] = 1, [4] = 0}, [3] = {[1] = 0.6, [2] = 0, [3] = 0.5, [4] = 0}},
                    ["Alignment"] = "Middle",
        
                },
                [4] = {
                    ["Order"] = 4,
                    ["Type"] = "PowerBar",
                    ["OffsetAbove"] = 0,
                    ["OffsetBelow"] = 0,
                    ["Height"] = 4,
                    ["Text"] = "",
                    ["Smooth"] = true,
                    ["Alignment"] = "Left",
                    ["Colours"] = {[1] = nil, [2] = {[1] = 0.6, [2] = 0, [3] = 0, [4] = 1}},
        
                },
                [5] = {
                    ["Order"] = 5,
                    ["Type"] = "ResourceBar",
                    ["Height"] = 20,
                    ["Width"] = 320,
                    ["Scale"] = 1,
                    ["ShowText"] = true,
                    ["OffsetAbove"] = 0,
                    ["OffsetBelow"] = 20,
                    ["ForegroundColour"] = {
                        [1] = {[1] = 0.8, [2] = 0, [3] = 0.4,  [4] = 0},
                        [2] = {[1] = 0.8, [2] = 0, [3] = 0.4,  [4] = 0},
                        [3] = {[1] = 0.8, [2] = 0, [3] = 0.4,  [4] = 0},
                        [4] = {[1] = 0.8, [2] = 0.4, [3] = 0.4,  [4] = 0},
                        [5] = {[1] = 0.8, [2] = 0.4, [3] = 0.4,  [4] = 0},
                        [6] = {[1] = 0.8, [2] = 0.4, [3] = 0.4,  [4] = 0},
                        [7] = {[1] = 0.8, [2] = 0.4, [3] = 0,  [4] = 0},
                        [8] = {[1] = 0.8, [2] = 0.4, [3] = 0,  [4] = 0},
                        [9] = {[1] = 0.8, [2] = 0.4, [3] = 0,  [4] = 0},
                    },
                    ["BackgroundColour"] = {
                        [1] = {[1] = 0.8, [2] = 0, [3] =0.8,  [4] = 0},
                        [2] = {[1] = 0.8, [2] = 0, [3] =0.8,  [4] = 0},
                        [3] = {[1] = 0.8, [2] = 0, [3] =0.8,  [4] = 0},
                        [4] = {[1] = 0.8, [2] =0.8, [3] =0.8,  [4] = 0},
                        [5] = {[1] = 0.8, [2] =0.8, [3] =0.8,  [4] = 0},
                        [6] = {[1] = 0.8, [2] =0.8, [3] =0.8,  [4] = 0},
                        [7] = {[1] = 0.8, [2] =0.8, [3] = 0,  [4] = 0},
                        [8] = {[1] = 0.8, [2] =0.8, [3] = 0,  [4] = 0},
                        [9] = {[1] = 0.8, [2] =0.8, [3] = 0,  [4] = 0},
                    },
                    ["BoxOffset"] = 3,
                    ["BorderSize"] = 0,
                    ["BorderColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
                    ["Alignment"] = "Middle",
                    ["RKLayout"] = false,
                    ["SecondForegroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
                    ["SecondBackgroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
                    ["BoxBackgroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
                },
                [6] = {
                    ["Order"] = 6,
                    ["Type"] = "ResourceBar",
                    ["Height"] = 20,
                    ["Width"] = 320,
                    ["Scale"] = 1,
                    ["ShowText"] = true,
                    ["OffsetAbove"] = 0,
                    ["OffsetBelow"] = 0,
                    ["BoxBackgroundColour"] =  {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
                    ["ForegroundColour"] = {
                        [1] = {[1] = 0.8, [2] = 0, [3] = 0.4,  [4] = 0},
                        [2] = {[1] = 0.8, [2] = 0, [3] = 0.4,  [4] = 0},
                        [3] = {[1] = 0.8, [2] = 0, [3] = 0.4,  [4] = 0},
                        [4] = {[1] = 0.8, [2] = 0.4, [3] = 0.4,  [4] = 0},
                        [5] = {[1] = 0.8, [2] = 0.4, [3] = 0.4,  [4] = 0},
                        [6] = {[1] = 0.8, [2] = 0.4, [3] = 0.4,  [4] = 0},
                        [7] = {[1] = 0.8, [2] = 0.4, [3] = 0,  [4] = 0},
                        [8] = {[1] = 0.8, [2] = 0.4, [3] = 0,  [4] = 0},
                        [9] = {[1] = 0.8, [2] = 0.4, [3] = 0,  [4] = 0},
                    },
                    ["BackgroundColour"] = {
                        [1] = {[1] = 0.8, [2] = 0, [3] =0.8,  [4] = 0},
                        [2] = {[1] = 0.8, [2] = 0, [3] =0.8,  [4] = 0},
                        [3] = {[1] = 0.8, [2] = 0, [3] =0.8,  [4] = 0},
                        [4] = {[1] = 0.8, [2] =0.8, [3] =0.8,  [4] = 0},
                        [5] = {[1] = 0.8, [2] =0.8, [3] =0.8,  [4] = 0},
                        [6] = {[1] = 0.8, [2] =0.8, [3] =0.8,  [4] = 0},
                        [7] = {[1] = 0.8, [2] =0.8, [3] = 0,  [4] = 0},
                        [8] = {[1] = 0.8, [2] =0.8, [3] = 0,  [4] = 0},
                        [9] = {[1] = 0.8, [2] =0.8, [3] = 0,  [4] = 0},
                    },
                    ["BoxOffset"] = 10,
                    ["BorderSize"] = 3,
                    ["RKLayout"] = false,
                    ["SecondForegroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
                    ["SecondBackgroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
                    ["BorderColour"] = {[1] = 1, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
                    ["Alignment"] = "Left",
                },
                [7] = {
                    ["Order"] = 7,
                    ["Type"] = "ResourceBar",
                    ["Height"] = 20,
                    ["Width"] = 320,
                    ["Scale"] = 1,
                    ["ShowText"] = true,
                    ["OffsetAbove"] = 30,
                    ["OffsetBelow"] = 0,
                    ["BoxBackgroundColour"] = {[1] = 0.6, [2] = 0, [3] = 0,  [4] = 0},
                    ["ForegroundColour"] = {[1] = 1, [2] = 152/288, [3] = 0,  [4] = 0},
                    ["BackgroundColour"] = {[1] = 1, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
                    ["BoxOffset"] = 2,
                    ["BorderSize"] = 3,
                    ["BorderColour"] = {[1] = 1, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
                    ["Alignment"] = "Right",
                    ["RKLayout"] = true,
                    ["SecondForegroundColour"] = {[1] = 1, [2] = 152/288, [3] = 0,  [4] = 0},
                    ["SecondBackgroundColour"] = {[1] = 1, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
                },
                [8] = {
                    ["Order"] = 8,
                    ["Type"] = "ValueBar",
                    ["Height"] = 20,
                    ["Width"] = 320,
                    ["Scale"] = 1,
                    ["ShowText"] = true,
                    ["OffsetAbove"] = 30,
                    ["OffsetBelow"] = 0,
                    ["BackgroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
                    ["BoxOffset"] = 2,
                    ["BorderSize"] = 3,
                    ["Alignment"] = "Middle",
                    ["BorderColour"] = {[1] = 1, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
                    ["ForegroundColour"] = {[1] = 1, [2] = 152/288, [3] = 0,  [4] = 0},
                    ["Effects"] = {
        
                    },
                    ["Skills"] = {
                        ["Encouraging Roar"] = 15,
                    },
                },
                [9] = {
                    ["Order"] = 9,
                    ["Type"] = "BarGroup",
                    ["Height"] = 20,
                    ["Width"] = 320,
                    ["Scale"] = 1,
                    ["OffsetAbove"] = 30,
                    ["OffsetBelow"] = 0,
                    ["BackgroundColour"] = {[1] = 1, [2] = 0.08, [3] = 0.58,  [4] = 0.08},
                    ["BoxOffset"] = 2,
                    ["BorderSize"] = 3,
                    ["Alignment"] = "Middle",
                    ["Xpos"] = 0,
                    ["BorderColour"] = {[1] = 1, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
                    ["Bars"] = {
                        [1] = {
                            ["Order"] = 1,
                            ["Type"] = "ValueBar",
                            ["Height"] = 20,
                            ["Width"] = 160,
                            ["Scale"] = 1,
                            ["ShowText"] = true,
                            ["OffsetAbove"] = 30,
                            ["OffsetBelow"] = 0,
                            ["BackgroundColour"] = nil,
                            ["BoxOffset"] = 2,
                            ["BorderSize"] = 3,
                            ["Alignment"] = "Middle",
                            ["Xpos"] = 0,
                            ["Ypos"] = 0,
                            ["Texture"] = "bar6",
                            ["BorderColour"] = {[1] = 1, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
                            ["ForegroundColour"] = {[1] = 1, [2] = 152/288, [3] = 0,  [4] = 0},
                            ["Effects"] = {
                
                            },
                        },
                        [2] = {
                            ["Order"] = 2,
                            ["Type"] = "ValueBar",
                            ["Height"] = 10,
                            ["Width"] = 160,
                            ["Scale"] = 1,
                            ["ShowText"] = true,
                            ["OffsetAbove"] = 30,
                            ["OffsetBelow"] = 0,
                            ["BackgroundColour"] = nil,
                            ["BoxOffset"] = 2,
                            ["BorderSize"] = 3,
                            ["Alignment"] = 3,
                            ["BorderColour"] = {[1] = 1, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
                            ["ForegroundColour"] = {[1] = 1, [2] = 152/288, [3] = 0,  [4] = 0},
                            ["Xpos"] = 160,
                            ["Ypos"] = 0,
                            ["Texture"] = "bar6r",
                            ["Effects"] = {
                
                            },
                        },
                        [3] = {
                            ["Order"] = 2,
                            ["Type"] = "ValueBar",
                            ["Height"] = 10,
                            ["Width"] = 160,
                            ["Scale"] = 1,
                            ["ShowText"] = true,
                            ["OffsetAbove"] = 30,
                            ["OffsetBelow"] = 0,
                            ["BackgroundColour"] = nil,
                            ["BoxOffset"] = 2,
                            ["BorderSize"] = 3,
                            ["Alignment"] = "Middle",
                            ["BorderColour"] = {[1] = 1, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
                            ["ForegroundColour"] = {[1] = 1, [2] = 152/288, [3] = 0,  [4] = 0},
                            ["Xpos"] = 160,
                            ["Ypos"] = 10,
                            ["Effects"] = {
                
                            },
                        },
                    },
                },
                [10] = {
                    ["Order"] = 10,
                    ["Type"] = "BuffBar",
                    ["Height"] = 20,
                    ["Width"] = 320,
                    ["Scale"] = 1,
                    ["ShowText"] = true,
                    ["OffsetAbove"] = 30,
                    ["OffsetBelow"] = 0,
                    ["BackgroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
                    ["BoxOffset"] = 2,
                    ["BorderSize"] = 3,
                    ["Alignment"] = "Middle",
                    ["TextAlignment"] = "BottomCenter",
                    ["StackTextAlignment"] = "TopCenter",
                    ["BorderColour"] = {[1] = 1, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
                    ["ForegroundColour"] = {[1] = 1, [2] = 152/288, [3] = 0,  [4] = 0},
                    ["Effects"] = {
                        ["Rallying Cry"] = {
                            ["Icon"] = true,
                            ["Time"] = true,
                            ["Highlight"] = true,
                        },
                    },
                    ["Skills"] = {
                        ["Low Strike"] = {
                            ["Icon"] = 1091400591,
                            ["Time"] = 15,
                            ["Higlight"] = false,
                        },
                        ["Dextrous Hook"] = {
                            ["Icon"] = true,
                            ["Time"] = true,
                            ["Highlight"] = true,
                        },
                    },
                    ["AllEffects"] = true,
                    ["OnlyDebuffs"] = false,
                    ["OnlyBuffs"] = true,
                    ["AllHighlight"] = false,
                },
                [11] = {
                    ["Order"] = 11,
                    ["Type"] = "Icon",
                    ["Height"] = 32,
                    ["Width"] = 32,
                    ["Scale"] = 1,
                    ["ShowText"] = true,
                    ["OffsetAbove"] = 30,
                    ["OffsetBelow"] = 0,
                    ["BackgroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
                    ["BoxOffset"] = 2,
                    ["BorderSize"] = 3,
                    ["Alignment"] = "Middle",
                    ["BorderColour"] = {[1] = 1, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
                    ["Icon"] = 1091400591,
                    ["AlwaysVisible"] = true,
                    ["Effects"] = {
                        ["Banner of Hope"] =  false,
                    },
                    ["Highlight"] = true,
                },
                [12] = {
                    ["Order"] = 12,
                    ["Type"] = "Timer",
                    ["Height"] = 40,
                    ["Width"] = 300,
                    ["Scale"] = 1,
                    ["ShowText"] = true,
                    ["OffsetAbove"] = 30,
                    ["OffsetBelow"] = 0,
                    ["BackgroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
                    ["BoxOffset"] = 2,
                    ["BorderSize"] = 3,
                    ["Alignment"] = "Left",
                    ["BorderColour"] = {[1] = 1, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
                    ["BackgroundColour"] = {[1] = 1, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
                    ["AlwaysVisible"] = true,
                    ["Timers"] = {
                        [1] = {
                            ["Icon"] = 1091400591,
                            ["Effects"] = {
        
                            },
                            ["PlayerHits"] = {
        
                            },
                            ["EnemyHits"] = {
                                ["a weak melee attack"] = 15,
                            },
                            ["Skills"] = {
        
                            },
                            ["Width"] = 300,
                            ["Text"] = "HELOOOOO",
                            ["Height"] = 20,
                            ["Offset"] = 2,
                            ["ForegroundColour"] = {[1] = 1, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
                            ["BackgroundColour"] = {[1] = 1, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
                            ["Time"] = 20,
                            ["Font"] = "TrajanProBold16",
                        },
                        [2] = {
                            ["Icon"] = 1091400591,
                            ["Effects"] = {
        
                            },
                            ["PlayerHits"] = {
                                ["Low Strike"] = 10,
                            },
                            ["EnemyHits"] = {
        
                            },
                            ["Skills"] = {
                                ["Low Strike"] = {
                                    ["Time"] = true,
                                }
                            },
                            ["Width"] = 300,
                            ["Text"] = "HELOOOOO",
                            ["Height"] = 20,
                            ["Offset"] = 2,
                            ["ForegroundColour"] = {[1] = 1, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
                            ["BackgroundColour"] = {[1] = 1, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
                            ["Time"] = true,
                            ["Font"] = "TrajanProBold16",
                        }
                    },
                },
                [13] = {
                    ["Order"] = 13,
                    ["Type"] = "Text",
                    ["Height"] = 32,
                    ["Width"] = 300,
                    ["Scale"] = 1,
                    ["ShowText"] = true,
                    ["OffsetAbove"] = 30,
                    ["OffsetBelow"] = 0,
                    ["BackgroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
                    ["BoxOffset"] = 2,
                    ["BorderSize"] = 3,
                    ["Alignment"] = "Middle",
                    ["Font"] = "TrajanProBold16",
                    ["Text"] = "HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH",
                    ["BorderColour"] = {[1] = 1, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
                    ["AlwaysVisible"] = false,
                    ["Effects"] = {
                        ["DNT - Defensive Posture"] =  true,
                        ["DNT - Mettle Shield"] =  true,
                    },
                },
            }
        },
        [2] = {
            ["InstanceLoad"] = nil,
            ["RoleLoad"] = nil,
            ["ClassLoad"] = nil,
            ["CharLoad"] = nil,
            ["Name"] = "Small test UI",
            ["PrimeUI"] = {
                [1] = {
                    ["Order"] = 1,
                    ["Type"] = "Timer",
                    ["Height"] = 64,
                    ["Width"] = 800,
                    ["Scale"] = 1,
                    ["ShowText"] = true,
                    ["OffsetAbove"] = 30,
                    ["OffsetBelow"] = 0,
                    ["BackgroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
                    ["BoxOffset"] = 2,
                    ["BorderSize"] = 0,
                    ["Alignment"] = "Left",
                    ["BorderColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
                    ["BackgroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
                    ["AlwaysVisible"] = false,
                    ["Timers"] = {
                        [1] = {
                            ["Icon"] = 1091838724,
                            ["Effects"] = {
                                --["Find the Path"] = 25,
                            },
                            ["PlayerHits"] = {
                                --["Trick: Enrage"] = 25,
                            },
                            ["EnemyHits"] = {
                                --["a weak melee attack"] = 15,
                                ["Erupting Earth"] = 25,
                            },
                            ["Skills"] = {
        
                            },
                            ["Width"] = 800,
                            ["Text"] = "IT'S GONNA BLOW",
                            ["Height"] = 64,
                            ["Offset"] = 2,
                            ["ForegroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
                            ["BackgroundColour"] =  {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
                            ["Time"] = 25,
                            ["Font"] = "TrajanProBold30",
                        },
                    },
                },
            }
        },
        [3] = {
            ["InstanceLoad"] = nil,
            ["RoleLoad"] = nil,
            ["ClassLoad"] = nil,
            ["CharLoad"] = nil,
            ["Name"] = "Icon test UI",
            ["PrimeUI"] = {
                [1] = {
                    ["Order"] = 1,
                    ["Type"] = "Icon",
                    ["Height"] = 32,
                    ["Width"] = 32,
                    ["Scale"] = 1,
                    ["OffsetAbove"] = 30,
                    ["OffsetBelow"] = 0,
                    ["BackgroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
                    ["BoxOffset"] = 2,
                    ["BorderSize"] = 3,
                    ["Alignment"] = "Middle",
                    ["BorderColour"] = {[1] = 1, [2] = 0.08, [3] = 0.08, [4] = 0.08},
                    ["Icon"] = 1091400591,
                    ["AlwaysVisible"] = false,
                    ["Effects"] = {
                        ["DNT - Defensive Posture"] =  true,
                        ["DNT - Mettle Shield"] =  true,
                    },
                    ["Highlight"] = true,
                },
            }
        }
    }

    self.UIData = LoadTable(Turbine.DataScope.Account, "PrimeUI")

    if not(self.UIData) then
        self.UIData = {}
    end

    self.ClassLut = {
        [Turbine.Gameplay.Class.Burglar] = "Burglar",
        [Turbine.Gameplay.Class.Captain] = "Captain",
        [Turbine.Gameplay.Class.Champion] = "Champion",
        [Turbine.Gameplay.Class.Guardian] = "Guardian",
        [Turbine.Gameplay.Class.Hunter] = "Hunter",
        [Turbine.Gameplay.Class.LoreMaster] = "LoreMaster",
        [Turbine.Gameplay.Class.Minstrel] = "Minstrel",
        [Turbine.Gameplay.Class.RuneKeeper] = "RuneKeeper",
        [Turbine.Gameplay.Class.Warden] = "Warden",
        [Turbine.Gameplay.Class.Beorning] = "Beorning",
        [Turbine.Gameplay.Class.Brawler] = "Brawler",
        [Turbine.Gameplay.Class.BlackArrow] = "BlackArrow",
        [Turbine.Gameplay.Class.Defiler] = "Defiler",
        [Turbine.Gameplay.Class.Reaver] = "Reaver",
        [Turbine.Gameplay.Class.Stalker] = "Stalker",
        [Turbine.Gameplay.Class.WarLeader] = "WarLeader",
        [Turbine.Gameplay.Class.Weaver] = "Weaver",
    } 

    self.DungeonNameTable = InstanceController:GetDungeonNameTable()


    self:Setup()
end

function PrimeUIHandler:Setup()
    for key, value in pairs(self.UIData) do
        if self:Permission(value) then
            self.tools[value.Name] = PrimeUI(value.PrimeUI, value.Name, value.X, value.Y, value.AdvancedMode, value.OOCLoad, value.ICLoad)
        end
    end
end

function PrimeUIHandler:Permission(data)    
    if data.NeverLoad then return false end
    if  (not(data.NeverLoad) and
        data.ClassLoad == "All" or data.ClassLoad == self.ClassLut[self.player:GetClass()]) and 
        (data.RoleLoad == "All" or data.RoleLoad == Roles:GetRoleText()) and 
        (data.LineLoad == "All" or data.LineLoad == Roles:GetLineText()) and
        (data.InstanceLoad == "All" or data.InstanceLoad == self.DungeonNameTable[Settings.InstanceVersion]) then
            return true
        else 
            return false
    end
end

function PrimeUIHandler:RecheckPermissions()
    for key, value in pairs(self.UIData) do
        local load = self:Permission(value)

        if load then
            -- Load if not loaded
            if not(self.tools[value.Name]) then
                self.tools[value.Name] = PrimeUI(value.PrimeUI, value.Name, value.X, value.Y, value.AdvancedMode, value.OOCLoad, value.ICLoad)
            end
        else
            -- Unload if loaded
            if self.tools[value.Name] then
                self.tools[value.Name]:UnloadObject()
                self.tools[value.Name] = nil
            end
        end
    end
end

function PrimeUIHandler:LoadUI()
    for key, value in pairs(self.tools) do       
        value:Setup()
    end
end

function PrimeUIHandler:AddUI(data)
    if not(self.tools[data.Name]) then
        table.insert(self.UIData, data)
        self.tools[data.Name] = PrimeUI(data.PrimeUI, data.Name, data.X, data.Y, data.AdvancedMode, data.OOCLoad, data.ICLoad)
        return true
    else
        ChatOutput("Failed to add PrimeUI: Rejected by handler")
        return false
    end
end

function PrimeUIHandler:UnloadUI()
    for key, value in pairs(self.tools) do       
        value:UnloadObject()
    end
end

function PrimeUIHandler:GetData()
    return self.UIData
end

function PrimeUIHandler:Refresh(name, newData)
    if self.tools[name] then
        self.tools[name]:UnloadObject()
        self.tools[name]:Setup(newData)
    end
end

function PrimeUIHandler:RefreshAndReorder(name, newData)
    if self.tools[name] then
        self.tools[name]:UnloadObject()
        self.tools[name]:Setup(newData)
    end
end

function PrimeUIHandler:Move(name)
    if self.tools[name] then
        local X, Y = self.tools[name]:ToggleMove()
        for key, value in pairs(self.UIData) do
            if value.Name == name then
                self.UIData[key].X = X
                self.UIData[key].Y = Y
            end
        end
    end
end

function PrimeUIHandler:ChangeUIMetaData(newData)
    for key, value in pairs(self.UIData) do
        if newData.Name == value.Name then
            self.UIData[key] = newData
            if self:Permission(newData) then
                if self.tools[newData.Name] then
                    self:Refresh(newData.Name, self.UIData[key]["PrimeUI"])
                end
            elseif self.tools[newData.Name] then
                self.tools[newData.Name]:UnloadObject()
            end
            self.UIData[key] = newData
            break
        end
    end

    self:RecheckPermissions()
end

function PrimeUIHandler:Delete(name)
    for key, value in pairs(self.UIData) do
        if value.Name == name then
            if self.tools[name] then
                self.tools[name]:UnloadObject()
                self.tools[name]:SetParent(nil)
                self.tools[name] = nil
            end
            self.UIData[key] = nil
        end
    end
end

function PrimeUIHandler:MoveAll()
    for key, value in pairs(self.UIData) do
        if self.tools[value.Name] then
            local X, Y = self.tools[value.Name]:ToggleMove()
            self.UIData[key].X = X
            self.UIData[key].Y = Y
        end
    end
end

function PrimeUIHandler:Save()
    SaveTable(Turbine.DataScope.Account, "PrimeUI", self.UIData);
end

function PrimeUIHandler:ReloadWithDelay()
    for key, value in pairs(self.tools) do
        value:ReloadWithDelay()
    end
end

function PrimeUIHandler:GetPrimeUICount()
    return tablelength(self.tools)
end


function PrimeUIHandler:GetTotalPrimeUICount()
    return tablelength(self.UIData)
end